//
//  AppDelegate.m
//  BitizenExample
//
//  Created by Andrea Magini on 19/02/13.
//  Copyright __MyCompanyName__ 2013. All rights reserved.
//

#import "AppDelegate.h"
#import "HelloWorldLayer.h"

@implementation BitizenExampleAppDelegate
@synthesize window=window_, glView=glView_;

- (void)applicationDidFinishLaunching:(NSNotification *)aNotification
{
	CCDirectorMac *director = (CCDirectorMac*) [CCDirector sharedDirector];

	// enable FPS and SPF
	[director setDisplayStats:YES];
	
	// connect the OpenGL view with the director
	[director setView:glView_];

	// EXPERIMENTAL stuff.
	// 'Effects' don't work correctly when autoscale is turned on.
	// Use kCCDirectorResize_NoScale if you don't want auto-scaling.
	[director setProjection:kCCDirectorProjection2D];
    [director setResizeMode:kCCDirectorResize_AutoScale];
    
    CGSize winSize =CGSizeMake(800, 600);
    [window_ setContentAspectRatio:NSMakeSize(winSize.width,winSize.height)];
    
    NSRect aFrame=[[NSScreen mainScreen] frame];
    aFrame=[[NSScreen mainScreen] frame];
	if (aFrame.size.width<=winSize.width || aFrame.size.height<=winSize.height) [window_ zoom:self];
	[glView_ setFrameSize:NSMakeSize(window_.frame.size.width,window_.frame.size.height)];
//   [glView_ setFrameSize:NSMakeSize(640,480)];

    // Enable "moving" mouse event. Default no.
	[window_ setAcceptsMouseMovedEvents:YES];
	
	// Center main window
	[window_ center];
	
	[director runWithScene:[HelloWorldLayer scene]];
}

- (BOOL) applicationShouldTerminateAfterLastWindowClosed: (NSApplication *) theApplication
{
	return YES;
}

- (void)dealloc
{
	[[CCDirector sharedDirector] end];
	[window_ release];
	[super dealloc];
}

#pragma mark AppDelegate - IBActions

- (IBAction)toggleFullScreen: (id)sender
{
	CCDirectorMac *director = (CCDirectorMac*) [CCDirector sharedDirector];
	[director setFullScreen: ! [director isFullScreen] ];
}

@end
