//
//  MyBitizen.m
//  BitizenExample
//
//  Created by Andrea Magini on 21/02/13.
//
//

#import "MyBitizen.h"

@implementation MyBitizen

static ccColor3B skinColors[] = {
    {247,224,194},
    {255,232,214},
    {136,119,82},
    {245,232,205},
    {144,110,38}
};

static ccColor3B hairColors[] = {
    {100,54,20},
    {232,255,37},
    {52,53,29},
    {209,136,103}
};



-(id) initWithScaleFactor:(float)pScaleFactor withPositionX:(int)positionX withPositionY:(int)positionY
{
    if( (self=[super init])) {
        scaleFactor = pScaleFactor;

        startSpriteX = positionX;
        startSpriteY = positionY;
        //disegno sprite
        
        [self setFemale:NO];
        
        //maglietta
        int shirtOffsetX=1 *scaleFactor;
        int shirtOffsetY=-3 *scaleFactor;
        CCSprite *shirt = [CCSprite spriteWithFile:@"bitizen-shirt.png"];
        [shirt setPosition:ccp(startSpriteX+shirtOffsetX,startSpriteY+shirtOffsetY)];
        shirt.scale = scaleFactor;
        ccColor3B shirtColor = ccc3(arc4random() % 255,arc4random() % 255,arc4random() % 255);
        [shirt setColor:shirtColor];
        [shirt.texture setAliasTexParameters];
        [self addChild:shirt z:200 tag:BitizenTags_shirt];
        
        //testa
        int headOffsetX = 1*scaleFactor;
        int headOffsetY = 2*scaleFactor;
        CCSprite *head = [CCSprite spriteWithFile:@"bitizen-head.png"];
        [head setPosition:ccp(startSpriteX+headOffsetX,startSpriteY+headOffsetY)];
        head.scale = scaleFactor;
        ccColor3B headColor = skinColors[ arc4random() % 5];
        [head setColor:headColor];
        [head.texture setAliasTexParameters];
        [self addChild:head z:100 tag:BitizenTags_head];
        
        
        //occhi
        int eyesOffsetX = 1*scaleFactor;
        int eyesOffsetY = 5*scaleFactor;
        eyes = [CCSprite spriteWithFile:@"bitizen-eyes.png"];
        [eyes setPosition:ccp(startSpriteX+eyesOffsetX,startSpriteY+eyesOffsetY)];
        eyes.scale = scaleFactor;
        ccColor3B eyesColor = ccc3(0,0,0);
        [eyes setColor:eyesColor];
        [self addChild:eyes z:600 tag:BitizenTags_eyes];
        //blink =[CCBlink actionWithDuration:1.5 blinks:1] ;
        
        //CCActionInterval *blink =[CCRepeatForever actionWithAction:[CCBlink actionWithDuration:1.5 blinks:1]];
        CCBlink *blink =[CCBlink actionWithDuration:.2 blinks:arc4random() %2];
        CCDelayTime *delay = [CCDelayTime actionWithDuration:(arc4random()%5)+3];
        
        CCSequence *sequence = [CCSequence actions:blink,[CCShow action],delay,[CCShow action],nil];
        
        CCRepeatForever *forever = [CCRepeatForever actionWithAction:sequence];
        
        [eyes runAction:forever];
        
        //pantaloni
        int pantsOffsetX=1*scaleFactor;
        int pantsOffsetY=-6*scaleFactor;
        CCSprite *pants = [CCSprite spriteWithFile:@"bitizen-pants.png"];
        [pants setPosition:ccp(startSpriteX+pantsOffsetX,startSpriteY+pantsOffsetY)];
        pants.scale = scaleFactor;
        ccColor3B pantsColor = ccc3(arc4random() % 255,arc4random() % 255,arc4random() % 255);
        [pants setColor:pantsColor];
        [pants.texture setAliasTexParameters];
        [self addChild:pants z:520];
        
        //scarpe
        int shoesOffsetX=1*scaleFactor;
        int shoesOffsetY=-7*scaleFactor;
        CCSprite *shoes = [CCSprite spriteWithFile:@"bitizen-shoes.png"];
        [shoes setPosition:ccp(startSpriteX+shoesOffsetX,startSpriteY+shoesOffsetY)];
        shoes.scale = scaleFactor;
        shoes.flipY=YES;
        ccColor3B shoesColor = ccc3(arc4random() % 255,arc4random() % 255,arc4random() % 255);
        [shoes setColor:shoesColor];
        [shoes.texture setAliasTexParameters];
        [self addChild:shoes z:510];

        
        
        
    }
    return self;
}

-(void)showSuite:(BOOL)flag{
    [[self getChildByTag:BitizenTags_suite]setVisible:flag];
}
-(void)showShirt:(BOOL)flag{
    [[self getChildByTag:BitizenTags_shirt]setVisible:flag];
}
-(void)showGlasses:(BOOL)flag{
    
    if (flag){
        //occhiali
        int glassesOffsetX = 1*scaleFactor;
        int glassesOffsetY = 5*scaleFactor;
        CCSprite *glasses = [CCSprite spriteWithFile:@"bitizen-glasses0.png"];
        [glasses setPosition:ccp(startSpriteX+glassesOffsetX,startSpriteY+glassesOffsetY)];
        glasses.scale = scaleFactor;
        [glasses.texture setAliasTexParameters];
        [self addChild:glasses z:620 tag:BitizenTags_glasses];
    }else{
        [self removeChildByTag:BitizenTags_glasses cleanup:NO];
    }

}
-(void)showHat:(BOOL)flag{
    if (flag){
        //hat
        int hatOffsetX = 1*scaleFactor;
        int hatOffsetY = 3*scaleFactor;
        CCSprite *hat = [CCSprite spriteWithFile:@"bitizen-bhat3.png"];
        [hat setPosition:ccp(startSpriteX+hatOffsetX,startSpriteY+hatOffsetY)];
        hat.scale = scaleFactor;
        [hat.texture setAliasTexParameters];
        [self addChild:hat z:620 tag:BitizenTags_hat];
    }else{
        [[self getChildByTag:BitizenTags_hat]setVisible:flag];
    }
}


-(void)setSuite:(int)suiteId{
    if (suiteId==0){
        //remove
        [self removeChildByTag:BitizenTags_suite cleanup:NO];
        return;
    }
    
    //SKIN
    int skinOffsetX=1*scaleFactor;
    int skinOffsetY=3*scaleFactor;
    CCSprite *skin;
    if (suiteId==1){
        skin =[CCSprite spriteWithFile:@"pirate.png"];
    }
    if (suiteId==2){
        skin =[CCSprite spriteWithFile:@"detective.png"];
    }
    
    if (suiteId==3){
        skin =[CCSprite spriteWithFile:@"barista.png"];
    }
    
    [skin setPosition:ccp(startSpriteX+skinOffsetX,startSpriteY+skinOffsetY)];
    skin.scale = scaleFactor;
    [skin.texture setAliasTexParameters];
    [self addChild:skin z:800 tag:BitizenTags_suite];
    

    
}
-(void)setFemale:(BOOL)flag{
    [self removeChildByTag:BitizenTags_hair cleanup:NO];
    CCSprite *hair ;
    if (flag){
        hair= [CCSprite spriteWithFile:@"bitizen-hair1.png"];
    }else{
        hair= [CCSprite spriteWithFile:@"bitizen-hair0.png"];
    }
    
    //capelli
    int hairOffsetX = 1*scaleFactor;
    int hairOffsetY = 10*scaleFactor;
    
    hair.anchorPoint =ccp(0.5,1);
    hair.color = hairColors[ arc4random() % 4];
    [hair setPosition:ccp(startSpriteX+hairOffsetX,startSpriteY+hairOffsetY)];
    hair.scale = scaleFactor;
    [hair.texture setAliasTexParameters];
    [self addChild:hair z:500 tag:BitizenTags_hair];
    
}


- (void) dealloc
{
	[super dealloc];
}

@end
